/***************************************************************************
                          block.h  -  description
                             -------------------
    begin                : Wed Mar 1 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BLOCK_H
#define BLOCK_H


/**Tetris-Stein

  *@author Michael Speck
  */

class Wave;

#include "sdl.h"

#define BOWL_W	    10
#define BOWL_H	    24
#define BOWL_MIN_Y  4
#define BOWL_PIX_W  160
#define BOWL_PIX_H  384
#define BLOCKSIZE	16

#define BLOCK_STOP		0
#define BLOCK_MOVE		1
#define BLOCK_NOMOVE	2

struct BlockInit {
	int rx, ry; //rotating point
	int blocks[4][4][4]; //1 block, 0 transparent
	int id;
};

class Block {
public: 
	Block(int *bwl, int smth, int bl_by_bl);
	~Block();
	void New(int px, int py, BlockInit *t, float pms, int hd);
	int Update(int ms);
	void RotLeft();
	void RotRight();
	void Left(int ms);
	void Right(int ms);
	int *State();
	int *OldState();
	int CheckDrop();
	void OldPos(int *ox, int *oy);
	void Pos(int *px, int *py);
	int X();
	float CurX();
	float OldCurX();
	int Y();
	int Id();
	int Rot();
	int CheckHori();
	int CheckRot();
	void SetOldX();
	void SetOldRot();
	void ForceSpeed(float pms);
	void SetHoriDelay(int d);
	void SetOld();
	void AdjustPos();
	void SetDropFlag(int f);
	int GetDropFlag();
	void DropFast();
	void ClearWaitDrop();
	
	int			x;
	float       cur_x;
	int			y;
	float		cur_y;
	float       old_cur_x;
	int			old_x;
	int			old_y;
	int			blocks[4][4][4];
	int			rotation; //index 0-3 in blocks
	int			old_rot;
	float		per_msec;
	int			*bowl;
	int 		id;
	int			add;
	int			last_left;
	int			last_right;
	int 		last_rot_left;
	int			last_rot_right;
	int			rot;
	float		forced_speed;
	int			hori_delay;
	Wave		*snd_leftright;
	Wave		*snd_drop;
	Wave		*snd_stop;
	int         smooth;
	int         bl_by_bl;
	int         drop_flag;
	int         wait_drop;
};

#endif
