/***************************************************************************
                          shrapnelllist.cpp  -  description
                             -------------------
    begin                : Mon Mar 6 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "shrapnelllist.h"

ShrapnellList::ShrapnellList()
{
	number = 0;
	head = new Shrapnell();
	tail = new Shrapnell();
	head->SetNext(tail);
	tail->SetPrev(head);
}

ShrapnellList::~ShrapnellList()
{
	Shrapnell *cur = head, *next;
	while (cur->Next()) {
		next = cur->Next();
		delete cur;
		cur = next;
	}
	delete cur;
}

void ShrapnellList::Add(Shrapnell *s)
{
	tail->Prev()->SetNext(s);
	s->SetPrev(tail->Prev());
	s->SetNext(tail);
	tail->SetPrev(s);
	number++;
}

void ShrapnellList::Delete(Shrapnell *s)
{
	s->Next()->SetPrev(s->Prev());
	s->Prev()->SetNext(s->Next());
	delete s;
	number--;
}

void ShrapnellList::Update(int ms)
{
	int i = number;
	Shrapnell	*cur = head->Next(), *next;
	while (i--) {
		next = cur->Next();
		if (!cur->Update(ms)) Delete(cur);
		cur = next;
	}
}

int ShrapnellList::Number()
{
	return number;
}

void ShrapnellList::Hide()
{
	Shrapnell *cur = head->Next();
	while (cur != tail) {
		cur->Hide();
		cur =cur->Next();
	}
}

void ShrapnellList::Show(SDL_Rect *rects, int *rect_num)
{
	Shrapnell *cur = head->Next();
	while (cur != tail) {
		cur->Show(rects, rect_num);
		cur = cur->Next();
	}
}

void ShrapnellList::GetBackgnd()
{
	Shrapnell *cur = head->Next();
	while (cur != tail) {
		cur->GetBackgnd();
		cur = cur->Next();
	}
}

